using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Shell.Flavor;

namespace Schaller.IconDemoPackage
{
	/// <summary>
	/// The project factory for our project flavor.
	/// </summary>
	[ComVisible( false )]
	[Guid( GuidList.guidIconDemoProjectFactoryPkgString)]
	public class IconDemoProjectFactory : FlavoredProjectFactoryBase
	{
		private IconDemoPackage m_objPackage;

		/// <summary>
		/// Initializes a new instance of the <see cref="IconDemoProjectFactory"/> class.
		/// </summary>
		/// <param name="package">The package.</param>
		public IconDemoProjectFactory( IconDemoPackage package )
			: base()
		{
			m_objPackage = package;
		}

		#region IVsAggregatableProjectFactory
		
		/// <summary>
		/// Create an instance of our project. The initialization will be done later
		/// when VS call InitalizeForOuter on it.
		/// </summary>
		/// <param name="outerProjectIUnknown">This is only useful if someone else is subtyping us</param>
		/// <returns>An uninitialized instance of our project</returns>
		protected override object PreCreateForOuter( IntPtr outerProjectIUnknown )
		{
			IconDemoProject objIconDemoProject = new IconDemoProject();
			objIconDemoProject.Package = this.m_objPackage;
			return objIconDemoProject;
		}

		#endregion
	}
}
